/*
	Noun suffix list of KSSM & KSC5601 code.

		N_NSFX = 41, NSFXSIZE = 7 --> defined at 'header/hdics.h'
*/

HAM_UCHAR nsfdic[2][N_NSFX][NSFXSIZE] = {
  {	/* KSSM code of 'nsf' */
	{ '\0' },		/* no suffix */
	{ 0x97, 0x69, '\0' },	/* 1: GzI: */
	{ 0xb8, 0xe2, '\0' },	/* 2: XfA: */
	{ 0xba, 0x97, '\0' },	/* 3: XsW: */
	{ 0x97, 0x77, '\0' },	/* 4: GzW: */
	{ 0x9c, 0x77, '\0' },	/* 5: IbW: */
	{ 0xaa, 0x85, '\0' },	/* 6: SsD: */
	{ 0xaf, 0xa2, '\0' },	/* 7: UiA: */
	{ 0xac, 0x77, '\0' },	/* 8: UbW: */
	{ 0xac, 0xf7, '\0' },	/* 9: UfW: */
	{ 0xd1, 0x77, '\0' },	/* 10: hjW: */
	{ 0xd1, 0xc1, '\0' },	/* 11: hlb:ȭ */
	{ 0xa5, 0x69, '\0' },	/* 12: RjI: */
	{ 0xb6, 0x77, '\0' },	/* 13: WrW: */
	{ 0xc3, 0x62, '\0' },	/* 14: ZzA: */
	{ 0x88, 0x65, '\0' },	/* 15: AbD: */
	{ 0xbc, 0x81, '\0' },	/* 16: Yc:° */
	{ 0xbd, 0xa2, '\0' },	/* 17: YlA: */
	{ 0xbf, 0x71, '\0' },	/* 18: YzQ: */
	{ 0xaf, 0xa1, '\0' },	/* 19: Ui: */
	{ 0x90, 0x81, '\0' },	/* 20: Dc: */
	{ 0xd0, 0x61, '\0' },	/* 21: hb: */
	{ 0x8c, 0xf5, '\0' },	/* 22: BfU: */
	{ 0xb3, 0xa2, '\0' },	/* 23: ViA: */
	{ 0xad, 0xa2, '\0' },	/* 24: UlA: */
	{ 0x96, 0xe1, '\0' },	/* 25: Gsi: */
	{ 0xb3, 0xa1, '\0' },	/* 26: Vi: */
	{ 0xa3, 0xb9, '\0' },	/* 27: QiZ: */
	{ 0xd2, 0x81, '\0' },	/* 28: hs: */
	{ 0x89, 0x77, '\0' },	/* 29: AjW: */
	{ 0x94, 0x77, '\0' },	/* 30: GbW: */
	{ 0x97, 0x69, 0xaa, 0x85, '\0' },	/* 31: GzISsD: */
	{ 0x8f, 0xa1, 0x9f, 0xa1, '\0' },	/* 32: BiIi: */
	{ 0x97, 0x69, 0x8f, 0xa1, 0x9f, 0xa1, '\0' },	/* 33: GzIBiIi:鳢 */
	{ 0xbc, 0x61, 0x9f, 0xa1, '\0' },	/* 34: YbIi:¥ */
	{ 0x97, 0x69, 0x88, 0x65, '\0' },	/* 35: GzIAbD:鰣 */
	{ 0xa1, 0x65, '\0' },	/* 36: QjD: */
	{ 0x91, 0x41, '\0' },	/* 37: Dg: */
	{ 0xb6, 0x41, '\0' },	/* 38: Wli: */
	{ 0x98, 0x81, 0xa2, 0x85, '\0' },	/* 39: HcQsD: */
	{ 0x97, 0x69, 0xba, 0x97, '\0' },	/* 40: GzIXsW: -- 2003.0120 ½ */
  },
  {	/* KSC5601 version of 'nsf' */
	{ '\0' },		/* no suffix */
	{ 0xb5, 0xe9, '\0' },	/* GzI */
	{ 0xc0, 0xfb, '\0' },	/* XfA */
	{ 0xc1, 0xdf, '\0' },	/* XsW */
	{ 0xb5, 0xee, '\0' },	/* GzW */
	{ 0xb6, 0xfb, '\0' },	/* IbW */
	{ 0xbb, 0xd3, '\0' },	/* SsD */
	{ 0xbd, 0xc4, '\0' },	/* UiA */
	{ 0xbb, 0xf3, '\0' },	/* UbW */
	{ 0xbc, 0xba, '\0' },	/* UfW */
	{ 0xc7, 0xfc, '\0' },	/* hjW */
	{ 0xc8, 0xad, '\0' },	/* hlb */
	{ 0xba, 0xb0, '\0' },	/* RjI */
	{ 0xbf, 0xeb, '\0' },	/* WrW */
	{ 0xc3, 0xf8, '\0' },	/* ZzA */
	{ 0xb0, 0xa3, '\0' },	/* AbD */
	{ 0xc2, 0xb0, '\0' },	/* Yc */
	{ 0xc2, 0xca, '\0' },	/* YlA */
	{ 0xc2, 0xeb, '\0' },	/* YzQ */
	{ 0xbd, 0xc3, '\0' },	/* Ui */
	{ 0xb3, 0xbb, '\0' },	/* Dc */
	{ 0xc7, 0xcf, '\0' },	/* hb */
	{ 0xb2, 0xaf, '\0' },	/* BfU */
	{ 0xbe, 0xbf, '\0' },	/* ViA */
	{ 0xbc, 0xd3, '\0' },	/* UlA */
	{ 0xb5, 0xda, '\0' },	/* Gsi */
	{ 0xbe, 0xbe, '\0' },	/* Vi */
	{ 0xb9, 0xd7, '\0' },	/* QiZ */
	{ 0xc8, 0xc4, '\0' },	/* hs */
	{ 0xb0, 0xe6, '\0' },	/* AjW */
	{ 0xb4, 0xe7, '\0' },	/* GbW */
	{ 0xb5, 0xe9, 0xbb, 0xd3, '\0' },	/* GzISsD */
	{ 0xb3, 0xa2, 0xb8, 0xae, '\0' },	/* BiIi */
	{ 0xb5, 0xe9, 0xb3, 0xa2, 0xb8, 0xae, '\0' },	/* GzIBiIi */
	{ 0xc2, 0xa5, 0xb8, 0xae, '\0' },	/* YbIi */
	{ 0xb5, 0xe9, 0xb0, 0xa3, '\0' },	/* 35: GzIAbD */
	{ 0xb8, 0xe9, '\0' },	/* 36: QjD */
	{ 0xb3, 0xd7, '\0' },	/* 37: Dg */
	{ 0xbf, 0xdc, '\0' },	/* 38: Wli */
	{ 0xb6, 0xa7, 0xb9, 0xae, '\0' },	/* 39: HcQsD */
	{ 0xb5, 0xe9, 0xc1, 0xdf, '\0' },	/* 40: GzIXsW: */
  }
};

